package controller

import (
	"git.tek.govt.hu/dowerx/chat/server/dao"
	"git.tek.govt.hu/dowerx/chat/server/dao/postgres"
	"git.tek.govt.hu/dowerx/chat/server/model"
	"git.tek.govt.hu/dowerx/chat/server/util"
)

type UserController struct {
	UserDAO dao.IUserDAO
}

func (c UserController) GetUser(username string) (model.User, *util.ChatError) {
	return c.UserDAO.Read(model.User{Username: username})
}

func MakeUserController() (UserController, *util.ChatError) {
	controller := UserController{}

	userDAO := postgres.UserDAOPG{}
	err := userDAO.Init()
	if err != nil {
		return controller, err
	}

	controller.UserDAO = userDAO

	return controller, nil
}
